/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 17.04.2008
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATtiny2313
Clock frequency     : 16,000000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 32
*****************************************************/      

// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATtiny2313


#pragma used+
sfrb DIDR=1;
sfrb UBRRH=2;
sfrb UCSRC=3;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb USICR=0xd;
sfrb USISR=0xe;
sfrb USIDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb GPIOR0=0x13;
sfrb GPIOR1=0x14;
sfrb GPIOR2=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb PCMSK=0x20;
sfrb WDTCR=0x21;
sfrb TCCR1C=0x22;
sfrb GTCCR=0x23;
sfrb ICR1L=0x24;
sfrb ICR1H=0x25;
sfrw ICR1=0x24;   // 16 bit access
sfrb CLKPR=0x26;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;   // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;   // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCCR0A=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb EIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb OCR0B=0x3c;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// for compatibility with the interrupt vector names from Atmel's datasheet


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned char len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned char size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned char size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib






                                            
          
//     

eeprom float division_factor = (0.5)      ;   

float K_div;

unsigned char  owf_flag = 0;  

unsigned char completed_flag = 0; 
unsigned char Int_Marker = 0;
  
unsigned int temp, dobavka = 0; 
unsigned int compA = 0x8001    ;
unsigned int Int_Start_Time, Int_Stop_Time, Result; 

///unsigned char i;


//     .
interrupt [3] void ext_int1_isr(void)
{   
switch (Int_Marker) {
                     case 0:      
                                    Int_Start_Time = TCNT1; 
                                    Int_Marker = 0xFC;  
                                    TCNT0 = 0;   //   0
                                    owf_flag = 0; //   
                                    break;
                     case 0xFC: 
                                    Int_Stop_Time = TCNT1; 
                                    Int_Marker = 0xEE  ; 
                                    TIMSK |=(1<<6) ;
                                    break;
     } 
}
   

//     0.     
interrupt [7] void timer0_ovf_isr(void)
{
  owf_flag++; //     
  if(owf_flag > 253) { 
                        Int_Marker = 0; 
                        completed_flag = 0;   // ,     . 
                        owf_flag = 0;
                        TIMSK &=~(1<<6) ; //   ,   Compare A Match
                       } 
}


//  ,     ,   OCR1A.  
interrupt [5] void timer1_compa_isr(void)
{   
 PORTD ^=(1<<4)  ;  
            
  if(completed_flag == 0xEE  )  {
                             temp = dobavka;          //   ,   temp
                             completed_flag = 0;   //  ,   
                             }

                            
  if((compA + temp) > 0xFFFF ) {  // ,           FFFF
                                   compA = ((compA + temp) - 0xFFFF); //  ,     .
                        } else {
                                   compA =  (compA + temp);   //   -  .
                               }
   OCR1A = compA;   //      . 
   
} 
     

void Measurement(void) {  

           if(Int_Start_Time < Int_Stop_Time) { 
                                               Result = Int_Stop_Time - Int_Start_Time;          
                                              } 
                                         else {
                                               Result = (0xFFFF - Int_Start_Time) + Int_Stop_Time;  
                                              } 
               
      Int_Marker = 0;           // ,    .    
}      



void Basis_cycle(void) {  
        #asm("wdr")  //   
       
       if(Int_Marker == 0xEE  ) {   //   INT1 ...   
       
       Measurement();  //    

 
         dobavka = (unsigned int)( ((unsigned long)(Result / K_div) + 1)  >> 1);

     
      if((TCCR1B == 0x03) && (Result > 31000) ) { //    ,  ;
                                                      TCCR1B = 0x05; 
                                                      dobavka = dobavka*16; //   16
                                                     }  
                                                     
      if((TCCR1B == 0x05) && (Result < 1200) )  { //    ,  ;
                                                     TCCR1B = 0x03; 
                                                     dobavka = dobavka/16; //   16
                                                    }
         
          completed_flag = 0xEE  ; //     ,     completed_flag.
          
                     
          } // end of "if(Int_Marker == SET)"  
}


char Start_of_calibration(void) { //   ,  
unsigned int counter; 
unsigned char num;
unsigned char buf[6];
float temp32 = 0.0;

counter = 0;

while ( (counter < 2000) && ((PINB.0) == 0) ) {  //    ,  2 .
                                           counter++; 
                                           #asm("wdr")  //   
                                           delay_ms(1);
                                           }
          if( counter < 2000 ) return;  //  -   - 
          
          (PORTD.6) = 1; //    
          
          while ((PINB.0) == 0) { #asm("wdr") } //    
          delay_ms(250); // 
            if((PINB.0) == 0) { //      -   
                                  (PORTD.6) = 0; //              
                                  return; 
                                 }  
            
// ***    ,            . *** 


         if( (PINB.7) == 1 ) {  //    ( ),     . 
         
         K_div = 1.0; //    
            #asm("sei")
            while ((PINB.0) == 1) { //    ... 
                                          Basis_cycle(); //..    .
                                        } 

               (PORTD.6) = 0; //    
               while(Int_Marker != 0xEE  ) { #asm("wdr") } //     
            #asm("cli")  
              TIMSK &=~(1<<6) ; //    Compare A Match,                 
            
            Measurement();  //    
            
            if((PINB.6) == 1)  { counter = 1497; }  // 10-. 
                         else  { counter = 2500; }  // 6-.      
                         
                          temp32 = (float)(counter / Result);    
 
                             } else {     //    -    UART  
                             
                             // USART initialization
                             // Communication Parameters: 8 Data, 1 Stop, No Parity
                             // USART Receiver: On
                             // USART Transmitter: Off
                             // USART Mode: Asynchronous
                             // USART Baud Rate: 19200
                                    UCSRA=0x00;
                                    UCSRB=0x10;
                                    UCSRC=0x06;
                                    UBRRH=0x00;
                                    UBRRL=0x33;
                                    
                                    buf[0] = getchar();
                                    buf[1] = getchar();
                                    buf[2] = getchar();
                                    buf[3] = getchar();
                                    buf[4] = getchar();
                                    buf[5] = getchar();    
                                    
                                 (PORTD.6) = 0; //       
                                 
                                    if((buf[0] == 0xA5) && (buf[5] == 0x5A) ) { 
                                                                               temp32 = *(float*)(&(buf[1]));   //     temp32
                                                                              }
                                    UCSRB=0x00;  //  UART
                                    }  
                                              
            if((temp32 > 0.30)&&(temp32 <= 3.0)) { //     ,    .
                                                  division_factor = temp32; 
                                                 } 
                                            else {
                                                   #asm("wdr")                 // ... .
                                                   (PORTD.6) = 0; //      
                                                   return;
                                                 }

            
// ***     -   3 . ***        

num = 6;
while (num) {  
             PORTD ^=(1<<6)  ;  //   .
             num--;     
             #asm("wdr")  //   
             delay_ms(1000);
            }  
 (PORTD.6) = 0; //      
 return;
}


void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;

// Input/Output Ports initialization
// Port A initialization
// Func2=In Func1=Out Func0=In 
// State2=P State1=0 State0=T 
PORTA=0x04;
DDRA=0x02;

// Port B initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In 
// State7=P State6=P State5=0 State4=0 State3=0 State2=0 State1=0 State0=T 
PORTB=0xC0;
DDRB=0x3E;

// Port D initialization
// Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=Out Func0=In 
// State6=0 State5=1 State4=0 State3=T State2=0 State1=0 State0=T 
PORTD=0x20;
DDRD=0x76;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x05;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 250,000 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x03;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=(0x8001    >>8);
OCR1AL=(0x8001     & 0xFF);
OCR1BH=0x00;
OCR1BL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: On
// INT1 Mode: Falling Edge
// Interrupt on any change on pins PCINT0-7: Off
GIMSK=0x80;
MCUCR=0x08;
EIFR=0x80;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x42;
TIMSK &=~(1<<6) ; //    . 

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
USICR=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/1024k
// Watchdog Timer interrupt: Off
#pragma optsize-
WDTCR=0x39;
WDTCR=0x29;


if((PINB.0) == 0) { Start_of_calibration(); } //    -           

 /*
if( SOURCE_TYPE == 1 ) { K_div = division_factor; } //    ( ),    
                  else { K_div = FLASH_VAL; }            //    -   .     
*/                                                              

K_div = division_factor;  //                    


// Global enable interrupts
#asm("sei")

while (1)
      {
      Basis_cycle();
      }
}
